---
title: Programming in C++
subtitle: WIP Templates
layout: layouts/presentation.njk

CoreCpp: https://github.com/isocpp/CppCoreGuidelines/blob/master/CppCoreGuidelines.md#
GoogleCpp: https://google.github.io/styleguide/cppguide.html#
---

<section>
  <section>
    <h2>What are C++ Templates</h2>
    <p><strong>Templates</strong> allow code blocks to
      operate with generic types</p>
    <p>A template describes a family of functions or classes that can work on
      many different data types without being rewritten for each one</p>
    <p class="fragment">The compiler generates the functions and classes for
      all required types within the same compilation unit
    </p>
    <div class="fragment">
      <p>C++ knows
      <ul>
        <li>function templates</li>
        <li>class templates</li>
        <li>variable templates (since C++14)</li>
      </ul></p>
    </div>
  </section>

  <section>
    <h2>Advantages of C++ Templates</h2>
    <p>Templates ...</p>
    <ul>
      <li>... allow
      <a href="https://en.wikipedia.org/wiki/Generic_programming">generic
        programming</a></li>
      <li>... avoid code duplication</li>
      <li>... improve maintainability</li>
      <li>... avoid some common errors of using of function-like macros</li>
    </ul>
  </section>

  <section>
    <h2>Disadvantages of C++ Templates</h2>
    <ul>
      <li>Not all compilers completely support templates</li>
      <li>Templates might affect the speed of compilation</li>
      <li>Compiler messages and errors are much harder to read</li>
      <li>Separate compilation model causes problems with separating
        declaration and definition
      </li>
    </ul>
  </section>
</section>

<section>
  <h2>Defining a C++ <code>template</code></h2>

  <section>
{% highlight "cpp" %}
template < parameter-list >
function-declaration

template < parameter-list >
class-declaration
{% endhighlight %}
  <p>For naming template parameters, <code>typename</code> and
  <code>class</code> are equivalent</p>
  </section>

  <section>
    <h3>Example: Maximum of Two Values</h3>
{% highlight "cpp 3,4" %}
{% include "source/cpp/templates/function.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/templates/function.cpp" %}
  </section>

  <section>
    <h3>Example: Working with a 2-tuple (Pair)</h3>
{% highlight "cpp" %}
{% include "source/cpp/templates/simple_pair.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/templates/simple_pair.cpp" %}
  </section>

  <section>
    <h3>Example: Working with a Pair of Different Types</h3>
{% highlight "cpp" %}
{% include "source/cpp/templates/pair.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/templates/pair.cpp" %}
  </section>
</section>

<section>
  <h2>Separate Declaration and Definition</h2>
  <section>
    <p>To use a <code>class</code> in other files, declare it in a header
      file</p>
    <p>Classes are usually also defined in header files</p>
    <p>Class methods are declared in the class definition but
      defined in a designated source file</p>
    <div class="fragment">
      <p>
      <a href="https://github.com/isocpp/CppCoreGuidelines/blob/master/CppCoreGuidelines.md#Rc-interface">
      C++ Core Guidelines</a></p>
      <ul>
        <li>Explicit distinction between interface (<kbd>*.hpp</kbd>) and
          implementation (<kbd>*.cpp</kbd>) improves
          readability and simplifies maintenance</li>
      </ul>
    </div>
  </section>

  <section>
    <h3>Example: Header File Contains the API</h3>
{% highlight "cpp 7,11-13" %}
{% include "source/cpp/oop/ds/int_vector.hpp" %}
{% endhighlight %}
{% download "/data/cpp/oop/ds/int_vector.hpp" %}
  </section>

  <section>
    <h3>Example: Source File</h3>
{% highlight "cpp 6,15,25" %}
{% include "source/cpp/oop/ds/int_vector.cpp" %}
{% endhighlight %}
{% download "/data/cpp/oop/ds/int_vector.cpp" %}
  </section>

  <section>
    <h3>Example: Use the <code>class</code></h3>
    <p>The <code>class</code> can be used from any other file</p>
{% highlight "cpp 0,4" %}
{% include "source/cpp/oop/ds/int_vector_main.cpp" %}
{% endhighlight %}
{% download "/data/cpp/oop/ds/int_vector_main.cpp" %}
    <p>Compile the program with
      <kbd>clang++ int_vector_main.cpp int_vector.cpp</kbd></p>
  </section>
</section>

{% include 'slides/closing.njk' %}
